/*
 * djgcc.c -- device dependent stuff for DJGCC compiler (DOS)
 *
 * (c) 1994 Shawn McHorse <Shawn_McHorse@fcircus.sat.tx.us>

   (<smchorse@ringer.cs.utsa.edu (?))
   this is part of Rayce, a raytracer based on "Ray" by George Kyriazis
   <kyriazis@turing.cs.rpi.edu> Rayce is released under the terms of the
   GNU General Public License, it has no warranty what so ever. For more
   details: see the file "COPYING"
 */

#include "ray.h"
#include "proto.h"
#include "extern.h"
#include <go32.h>
#include <dpmi.h>
#include <time.h>

PUBLIC void
        check_abort(void)
{
    if (keyboard_exit)
        if (_go32_was_ctrl_break_hit())
            abort_trace(0);
        else
            return;
}

PRIVATE time_t t0;

PUBLIC void
        timer_start(void)
{
    time(&t0);                  /* Get starting time. */
}

PUBLIC long
        timer_stop(void)
{
    time_t  t1;
    time(&t1);                  /* Get ending time. */
    return (long) 10 *difftime(t1, t0); /* Return time difference, in tenths of seconds. */
}

PUBLIC void
        install_handlers(void)
{
    return;
}

PUBLIC void
        init_machine(void)
{
    _go32_want_ctrl_break(1);   /* Tell GO32 to trap Ctrl-Break */
}
#ifdef UNDEFINED
PUBLIC unsigned long
        memory_left(void)
{
    return (_go32_dpmi_remaining_physical_memory() +
            _go32_dpmi_remaining_virtual_memory());
}
#endif
