/*
 *  ibmtcc.c -- device dependent stuff for Turbo C compiler (DOS)

   (c) 1993, 1994, 1995 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>

   this is part of Rayce, a raytracer based on "Ray" by George Kyriazis
   <kyriazis@turing.cs.rpi.edu> Rayce is released under the terms of the
   GNU General Public License, it has no warranty what so ever. For more
   details: see the file "COPYING"
*/

#include <bios.h>
#include <time.h>
#include <signal.h>
#include <alloc.h>


#include "ray.h"
#include "proto.h"
#include "extern.h"

#include "getopt.c"

extern unsigned int _stklen = (unsigned) 16384; // DOS Sux.

/* check for an abort condition, such as keypress */
PUBLIC void
        check_abort(void)
{
    if (keyboard_exit)
        if (bioskey(1))
        {
            abort_trace(0);
        } else
            return;
}

PRIVATE clock_t ts;
/* start the timer.*/
PUBLIC void
        timer_start(void)
{
    ts = clock();
}
/*
 *  stop the timer, and return difference in time, measured in tenth of
 * econds from last call to timer_start()
*/
PUBLIC long
        timer_stop(void)
{
    clock_t st;
    st = clock();

    return (long) ((10 * (st - ts)) / CLOCKS_PER_SEC);
}
/*
 *  131 == div by zer 129 == domain
 */

PRIVATE void
        sigcatch(int sig, int type, int *reglist)
{
    printf("trapped sig %d, type %d\n", sig, type);
}

PUBLIC void
        init_machine(void)
{
#ifdef DEBUG
    signal(SIGFPE, sigcatch);
#else
    signal(SIGFPE, SIG_IGN);
#endif
}
