
/*
   linux.cc -- device dependent stuff for Linux GCC
 

   (c) 1993, 1994, 1995 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>

   this is part of Rayce, a raytracer based on "Ray" by George Kyriazis
   <kyriazis@turing.cs.rpi.edu> Rayce is released under the terms of the
   GNU General Public License, it has no warranty what so ever. For more
   details: see the file "COPYING"
 */

#include <time.h>
#include <signal.h>
#include "proto.hh"
#include "extern.hh"

/* check for an abort condition, such as keypress */
void
check_abort()
{
}

PRIVATE clock_t ts;

/* start the timer. */
void
timer_start()
{
    ts = clock();
}
/*
 * stop the timer, and return the number of seconds from last call to
 * timer_start() in 10ths of secs.
 */
PUBLIC long
        timer_stop()
{
    clock_t st;
    st = clock();
    return (long) ((10 * (st - ts)) / CLOCKS_PER_SEC);
}

#ifdef DEBUG
PRIVATE void
sighandler(int bla)
{
    warning("Caught sig %d\n", bla);
}
#endif

void
mynewhandler()
{
    errormsg("Out of free store memory. Sorry");
}

void
init_machine()
{
#ifdef DEBUG
    signal(SIGFPE, sighandler);
#else
    /* ignore floating point errors */
    signal(SIGFPE, SIG_IGN);
#endif
    signal(SIGINT, abort_trace);

    if (silent_mode)
        signal(SIGHUP, SIG_IGN);
    set_new_handler(&mynewhandler);
}
