/*
 * sun.cc - device independent replacement for 

   (c) 1993, 1994, 1995 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>

   this is part of Rayce, a raytracer based on "Ray" by George Kyriazis
   <kyriazis@turing.cs.rpi.edu> Rayce is released under the terms of the
   GNU General Public License, it has no warranty what so ever. For more
   details: see the file "COPYING"
 */

#include "ray.h"
#include "proto.h"
#include <signal.h>


PUBLIC void        check_abort(void)
{
 
}

#define CLOCKS_PER_SEC (1/60.0)
extern "C" {
long clock();
}
PRIVATE clock_t ts;
/* start the timer. Using clock ticks isn't exactly elegant, but it works */
void
timer_start()
{
    ts = clock();
}

/*
 * stop the timer, and return the number of seconds from last call to
 * timer_start() in 10ths of secs.
 */
PUBLIC long
        timer_stop()
{
    clock_t st;
    st = clock();
    return (long) ((10 * (st - ts)) / CLOCKS_PER_SEC);
}

PUBLIC
void
install_handlers(void)
{

}

PUBLIC void
        init_machine(void)
{
    signal(SIGINT, abort_trace);
}
