/*
   This scene is (c) 1995 Han-Kwang Nienhuys

   Distributed under terms of the GPL.
*/
/*

First valve: valve + first pump

Reference: bottom of valve

*/

#declare torus38 = intersection {  // connect slide/valve
    torus { 6.5, 6.5 }
    plane { x, 0 }
    plane { <-0.707, 0, 0.707>, 0 }
    translate <0, 0, 6.5>
}

#declare valve3tune = composite {  // ref: center of tube
  intersection {
    torus { 13, 2.5 }
    cylinder { -2.5*y, 2.5*y, 13 }
    rotate x*90
  }
  translate <0,7+13,0>
  object { las3 }
  texture { nickelsilver }
}

#define v3ftp = 30 // fine tune position
#define v3rad = 7 // was 7.5

#declare valve3finetune = composite { // reference: bottom side of adj. , at ...
    cylinder { <0>, y*10, 3 }
    object { las1 rotate z*180 translate (v3rad+10)*y}
    cylinder { <15, 0, 0>, <15, 10, 0>, 3 }
    object { las1 rotate z*180 translate <15,v3rad+10,0>}
    cylinder { <-4, 4, 0>, <50, 4, 0>, 1.5 }
    cylinder { <v3ftp, 4, 0>, <v3ftp+4, 4, 0>, 4 }
    cylinder { <v3ftp+4, 4, 0>, <v3ftp+10, 4, 0>, 2.5 }
    cylinder { <v3ftp+10, 4, 0>, <v3ftp+14, 4, 0>, 4 }
    texture { nickelsilver }
}

#declare cbuttonsl3 = composite { // connection upper and lower part of slide 3. Ref: center of connection
  sphere { <0>, 4 scale <1,0.75,1> }
  object { las2 translate <0,-10,0> }
  object { las2 rotate z*180 translate <0,10,0>}  
  texture { trumpetbrass }
}

#declare slide3 = composite { // reference: center of valve#3, at lowest tube of slide
// (mirrored x=-x) temporary reference point beginning of lowest tube    
    object { torus38 }
    object { connring translate x*2 }
    cylinder { <0>, x*113, v3rad texture { nickelsilver } }
    object { connring translate x*111 }
    intersection {
        torus { 10, 6.5 rotate x*90 }
        plane { -x, 0 }
        translate <113, 10, 0>
    }
    object { connring translate <111, 20, 0> }
    cylinder { <113, 20, 0>, <0, 20, 0>, v3rad texture { nickelsilver } }
    object { connring translate <2, 20, 0> }
    object { torus38 translate y*20 }
    
    object { valve3tune translate <33, 20, 0> } // tuning ring (for little finger)
    object { cbuttonsl3 translate <77, 10, 0> }                        // connection upper/lower tube
    object { cbuttonsl3 translate <97, 10, 0> }                        // connection upper/lower tube
    object { valve3finetune translate <60, -16.5, 0> }
    cylinder { <123, 10, 0>, <123, 10, -7.1>, 4.4 }    // 'button' at end of slide
    sphere { <123, 10, -7.1>, 4.4 }
    
    object { slideconnect translate <18, 20, 0> }
    object { slideconnect translate <66, 0, 0> }
    object { slideconnect translate <108, 0, 0> }
    object { slideconnect translate <108, 20, 0> }
    
    translate <10, 0, -6.5>
    scale <-1, 1, 1>
}

#declare valve3 = composite {
    object { valve }
    object { slide3 translate y*35.5 }
}
