/*
    (c) 1993, 1994, 1995 Han-Wen Nienhuys <hanwen@stack.urc.tue.nl>
  It is based on "Ray" by George Kyriazis <kyriazis@turing.cs.rpi.edu>
  */

#ifndef COLOR_H
#include "vector.hh"

class nc_color : public nc_vector
{
 public:
    flt & r() {
        return x;
    }
    flt   &  g() {
        return y;
    }
    flt    & b(){
        return z;
    }
    void operator *= (const nc_color & c1);
    void operator *= (flt c1) { nc_vector::operator *= (c1) ; }
    void print() const ;
};

nc_color operator *(const nc_color & c1, const nc_color & c2);
inline nc_color operator *(flt f, nc_color c2) {
    c2 *= f;
    return c2 ;
}

inline nc_color operator *(nc_color c2,flt f) {
    c2 *= f;
    return c2 ;
}



class Color : public nc_color
{
 public:
    Color() { }
    // auto typecast from nc_color
    Color(const nc_color & v)
    {
        x = v.x;
        y = v.y;
        z = v.z;
    }
    Color(const nc_vector & v)
    {
        x = v.x;
        y = v.y;
        z = v.z;
    }
    Color(const flt a)
    {
        x = y = z = a;
    }
    Color(flt inr, flt ing,  flt inb)
    {
        x = inr;
        y = ing;
        z = inb;
    }
    flt     length();
    void normalise();
};

struct byte_color {
    byte r,g,b;
    byte_color(byte ir,byte ig,byte ib) { r = ir; g = ig; b=ib; }
    operator color () { return color(r/255.0, g/255.0, b/255.0); }
    byte_color() { }	// for arrays
	
    byte_color(color &c) {
	color k(c);
	k.normalise();

	r = int (k.r() * 255);      /* TGA is BGR */
	g = int (k.g() * 255);
	b = int (k.b() * 255);
    }
};
#define COLOR_H
#endif
