#ifndef GRID_HH
#define GRID_HH
struct Grid_tree
{
    Grid   *root;
    Grid_tree *reflect,         /* children */
           *refract;
    int    *indices,            /* indices to global grid */
           *shadowindices,      /* indices to shadow grid */
            last,
            shadowlast,
            recursion;

    void print() const ;
    Grid_tree(Grid *, int);
    ~Grid_tree();
    void    sample(flt &u, flt & v, flt & f, int raytype);
};

enum
{
    NO_FILTER,
    GAUSS_FILTER
};

struct Grid
{
    flt    *the_grid,
           *filter,
            filterconst,
            jitter_width_x,
            jitter_width_y;
    int     grid_len,
            filter_type;

    Grid_tree *tree;
            Grid();
    ~Grid();
    void    precompute();
    void print() const ;
    void    sample(flt &u, flt &v, flt & f, int raytype);
};

#endif
