/*-*-c++-*-*/

/* a 4x4 matrix, 3x3 for rotation, an extra column for translation */

#ifndef MATRIX_H
#define MATRIX_H

#include "vector.hh"

class matrix
{
    flt a[16];
public:
    void print() const ;
    matrix()
	{
	}

    void diag(const flt d);
    matrix(const flt b)
	{
	    diag(b);
	}
    void null()
	{                           /* initialize m to the null matrix */
	    diag(0);
	}

    /* m := diag(1,1,..) */
    void unit()
	{
	    diag(1);
	}

    void    translate(vector t);
    void    inv_translate(vector t);
    matrix  transpose() const;        /* transpose a matrix. Return = a^Transpose; */
    void    rotate(vector r);
    void inv_rotate(vector r);
    void    scale(vector s);
    void    inv_scale(vector s);
    void    make_rotation(vector v);
    const flt * operator[](int i) const
	{
	    return (a + i*4);
	}
    flt *operator[] (const int i)
	{
	    return (a + i*4);
	}
};


matrix operator *(const matrix & d, const matrix & b);  // multiply matrix a with matrix
vector operator *(const matrix & A, const vector & x);  // matrix vector product: multiply  a 3x3 (or 4x4) matrix with columnvector
// x
vector transform_normal(const matrix & A, const vector & n);   /* multiply with transpose of A */
vector operator *(const matrix & A, const direction & x);       // matrix-vector multiply, but don't use translation.
vector transform_direction(const matrix & A, const vector & x);        // matrix-vector multiply, but don't use translation.

#endif


